function [ remainingNodes, GLOBAL_U, GLOBAL_L, ind_nextNode ] = bb_initialization_7p( Jvalues, S, interv, step, prec, crossterm, etah, expcst, dataType )


% - Discretization of the (h_1,h_2) space --> (h1,h2,rhox)
[ set_h1h2rho ] = discr_h1h2_vprec( interv.h1, interv.h2, interv.rho, step, prec );



GLOBAL_U        = +Inf;
GLOBAL_L        = +Inf;
ind_nextNode    = 1;


% - Constraint h1 <= h2
ind_pruned = [];
for ii=1:size(set_h1h2rho,1)*size(set_h1h2rho,2)
    [ h1b, h2b ] = bb_constrh1leqh2( set_h1h2rho(ii).h1, set_h1h2rho(ii).h2 );
    if (isempty(h1b) && isempty(h2b)) || sum(isinf(set_h1h2rho(ii).rx)) > 0
        ind_pruned(end+1) = ii;
    else
        set_h1h2rho(ii).h1 = h1b;
        set_h1h2rho(ii).h2 = h2b;
    end
end
set_h1h2rho(ind_pruned) = [];




%/!\ Avant set_h1h2_rho de taille ('..' x '...) et maintenant ('1 x '...')
for ii=1:length(set_h1h2rho)
    interv_tmp                  = interv;
    interv_tmp.h1               = set_h1h2rho(ii).h1;
    interv_tmp.h2               = set_h1h2rho(ii).h2;
    interv_tmp.rho              = set_h1h2rho(ii).rx;

    L                           = ia2LowerBoundGeneral_7p( Jvalues, S, interv_tmp, crossterm, etah, expcst, dataType);
    U                           = eval2UpperBoundGeneral_7p( Jvalues, S, interv_tmp, crossterm, etah, expcst, dataType);
    remainingNodes(ii).L        = L;
    remainingNodes(ii).U        = U;
    remainingNodes(ii).interv   = interv_tmp;
    
    
    if L < GLOBAL_L
        GLOBAL_L        = L;
        ind_nextNode    = ii;
    end
    if U < GLOBAL_U
        GLOBAL_U        = U;
    end
    
end














end




