function [ remainingNodes, ind_lb  ] = bb_pruning( remainingNodes, GLOBAL_U )
%  bb_pruning: prune all the nodes belonging to 'remainingNodes' whose
%  lower bound is higher than 'GLOBAL_U'.

ind_pruned  = [];
ind_lb      = 1;
Lmin        = +Inf;



method = 'new';



if strcmp(method,'new')

    % - Pruning by bounds
    lb_list     = [remainingNodes.L];
    ind_pruned  = lb_list > GLOBAL_U;
    remainingNodes(ind_pruned) = [];
    
    % - Searching for node with lowest lower bound
    lb_list     = [remainingNodes.L];
    [~, ind_lb] = min(lb_list);

    
    
% else
%     
%     % - Pruning by bounds
%     for k = 1:length(remainingNodes)
%         
%         if remainingNodes(k).L > GLOBAL_U;
%             ind_pruned =  [ind_pruned, k];
%         end
%     end
%     
%     remainingNodes(ind_pruned) = [];
%     
%     
%     
%     
%     % - Searching for node with lowest lower bound
%     for k = 1:length(remainingNodes)
%         
%         if remainingNodes(k).L <= Lmin;
%             if remainingNodes(k).L == Lmin
%                 if randn > 0
%                     Lmin = remainingNodes(k).L;
%                     ind_lb  = k;
%                 end
%             else
%                 Lmin = remainingNodes(k).L;
%                 ind_lb = k;
%             end
%         end
%         
%     end
%     
%     
% end




end

