function [ node, remainingNodes ] = bb_selectNode( remainingNodes )
% bb_selectNode: select a node within 'remainingNodes'.

STRATEGY = 1;



switch STRATEGY
    
    case 1              % Select node with lowest lower bound
        Lmin = +Inf;
        ind  = 1;
        for k = 1:length(remainingNodes)
            if remainingNodes(k).L <= Lmin;
                if remainingNodes(k).L == Lmin
                    if randn > 0
                        Lmin = remainingNodes(k).L;
                        ind  = k;
                    end
                else
                    Lmin = remainingNodes(k).L;
                    ind  = k;
                end
            end
        end
        
        
    case 2              % Select node with largest interval
        Lmax = -Inf;
        ind  = 1;
        for k = 1:length(remainingNodes)
           if bb_sizeInterval(remainingNodes(k)) >= Lmax
               Lmax = bb_sizeInterval(remainingNodes(k));
               ind  = k;
           end
        end
        
        
    case 3              % Select node at random
        K   = length(remainingNodes);
        ind = randi(K,1); 
end




node                = remainingNodes(ind);
remainingNodes(ind) = [];


end

