function [ ub ] = eval2UpperBoundGeneral_7p( Jvalues, S, interv, crossterm, etah, expcst, dataType)
%EVAL2UPPERBOUND Summary of this function goes here
%   Detailed explanation goes here



rv      = 10^4;


h1      = ia_mid(interv.h1);%interv.h1(1)      + rand*(ia_length(interv.h1)); %
h2      = ia_mid(interv.h2);%interv.h2(1)      + rand*(ia_length(interv.h2)); %
s1      = ia_mid(interv.sigma1);%interv.sigma1(1)  + rand*(ia_length(interv.sigma1)); %
s2      = ia_mid(interv.sigma2);%interv.sigma2(1)  + rand*(ia_length(interv.sigma2)); %
rho     = ia_mid(interv.rho);%interv.rho(1)     + rand*(ia_length(interv.rho)); %
beta    = ia_mid(interv.beta);%interv.beta(1)    + rand*(ia_length(interv.beta)); %
gamma   = ia_mid(interv.gamma);%interv.gamma(1)   + rand*(ia_length(interv.gamma)); %


if strcmp(dataType,'ofbm');
    eta1    = etah(round(h1*rv)+1);
    eta2    = etah(round(h2*rv)+1);
    eta12   = etah(round((h1+h2)/2*rv)+1);
else
    eta1    = etah.val(Jvalues,round(h1*rv)+1);
    eta2    = etah.val(Jvalues,round(h2*rv)+1);
    eta12   = etah.val(Jvalues,round((h1+h2)/2*rv)+1);
end

l1      = s1^2          * eta1  * (1 + gamma^2)^(-1);
l12     = rho*s1*s2   * eta12 * (1 + gamma^2)^(-1/2) * (1 + beta^2)^(-1/2);
l2      = s2^2          * eta2  * (1 + beta^2)^(-1);


e1      = 2.^(Jvalues.*(2*h1+expcst));
e2      = 2.^(Jvalues.*(2*h2+expcst));
e12     = 2.^(Jvalues.*(h1+h2+expcst));


axx1    = l1;
axx12   = 2*l12*beta;
axx2    = l2*beta^2;


ayy1    = l1*gamma^2;
ayy12   = -2*l12*gamma;
ayy2    = l2;


Exx     = axx1.*e1    + axx12.*e12       + axx2.*e2;
Eyy     = ayy1.*e1    + ayy12.*e12       + ayy2.*e2;




diffxx  = (log2(S.xx)-log2(Exx)).^2;
diffyy  = (log2(S.yy)-log2(Eyy)).^2;


if crossterm
    axy1    = l1*(-gamma);
    axy12   = l12*(1-beta*gamma);
    axy2    = l2*beta;

    Exy     = axy1.*e1    + axy12.*e12       + axy2.*e2;
    diffxy  = (log2(abs(S.xy))-log2(abs(Exy))).^2;

    ub      = sum(diffxx) + sum(diffyy) + sum(diffxy);
else
    ub      = sum(diffxx) + sum(diffyy);
end



if ~isreal(ub)
    h1
    h2
    expcst
    disp('ub not real');
    %pause;
end

if isnan(ub)
    disp('ub not a number');
end



end

