function [ ens ] = discr_h1h2_vprec_v2( h1, h2, rho, step, prec )


if step == 1;
    step = 2;
end



% - Ensure not to exceed the expected accuracy
if length(h1) > 1
    step_h1         = max( (h1(2)-h1(1))/(step-1), prec.h1);
    h1_dscr         = [h1(1):step_h1:h1(2)];
    h1_dscr(end)    = max(h1_dscr(end), h1(2));
else
    h1_dscr     = [h1 h1];
end

if length(h2) > 1
    step_h2         = max( (h2(2)-h2(1))/(step-1), prec.h2);
    h2_dscr         = [h2(1):step_h2:h2(2)];
    h2_dscr(end)    = max(h2_dscr(end), h2(2));
else
    h2_dscr     = [h2 h2];
end




%%


for ii=1:length(h1_dscr)-1
    h1_m = h1_dscr(ii);
    h1_p = h1_dscr(ii+1);
    
    for jj=1:length(h2_dscr)-1
        h2_m = h2_dscr(jj);
        h2_p = h2_dscr(jj+1);
        
        
        lim_mm = (gamma(2*h1_m+1)*gamma(2*h2_m+1)*sin(pi*h1_m)*sin(pi*h2_m))/(gamma(h1_m+h2_m+1)*sin(pi*(h1_m+h2_m)/2))^2;
        lim_mp = (gamma(2*h1_m+1)*gamma(2*h2_p+1)*sin(pi*h1_m)*sin(pi*h2_p))/(gamma(h1_m+h2_p+1)*sin(pi*(h1_m+h2_p)/2))^2;
        lim_pm = (gamma(2*h1_p+1)*gamma(2*h2_m+1)*sin(pi*h1_p)*sin(pi*h2_m))/(gamma(h1_p+h2_m+1)*sin(pi*(h1_p+h2_m)/2))^2;
        lim_pp = (gamma(2*h1_p+1)*gamma(2*h2_p+1)*sin(pi*h1_p)*sin(pi*h2_p))/(gamma(h1_p+h2_p+1)*sin(pi*(h1_p+h2_p)/2))^2;
       
        
        lim = sqrt(min([lim_mm lim_mp lim_pm lim_pp]));
        
        
        ens(ii,jj).h1   = [h1_m h1_p];
        ens(ii,jj).h2   = [h2_m h2_p];
        
        if lim < rho(1)
            ens(ii,jj).rx   = Inf;
            %tmp(ii,jj)      = Inf;
        else
            %ens(ii,jj).rx   = [0 lim];
            
            if ia_length(rho) == 0
                %rho_min         = rho;%max(0, rho);
                %rho_max         = rho;%min(lim, rho);
                ens(ii,jj).rx   = rho;
                %tmp(ii,jj)      = rho;
            else
                rho_min         = max( 0, rho(1) );
                rho_max         = min( lim, rho(2) );
                ens(ii,jj).rx   = [rho_min rho_max];
                %tmp(ii,jj)      = rho_max;
            end
            
            
            
        end
        
        
    end
end


%figure(2);clf;
%surf(tmp)


