function int = etahOfGn(h,j,Nwt)
%coeffOndelette: returns the result of following integral:
% (-1/2) * integral_R { |u|^(2h) du } * integral_R { psi(v)*psi(u-v) dv },
% where 'h' stands for an Hurst exponent and 'psi' corresponds to the
% Daubechies 'Nwt' tap wavelet.
%
% Input : - 'h' Hurst exponent
%         - 'Nwt' (=2 by default)
%         - 'method' (=1 by default) permits to choose the ingretation
%            technique




nbvoies     = 15;


[u2, Psi2]  = genDaubechies2(nbvoies,Nwt);
du          = diff(u2);
[val ind]   = max(abs(Psi2));
u2          = u2 - u2(ind);
Psi2        = Psi2./val;



tmp         = 2^(2*j)*(1/2)*(abs(u2+2^(-j)).^(2*h) + abs(u2-2^(-j)).^(2*h) - 2*abs(u2).^(2*h)).*Psi2.*du(1);
int         = sum( tmp);



end




