function [ ta, a ] = genDaubechies2(nbvoies, regu, disp)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% genDaubechies.m                                    %
%                                                    %
% from 'synthond00.m'  (P. Abry, 06/10/93)           %
% dependency: listcoefdaub.m                         %
%                                                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%nbvoies = 3;
%regu    = 2; (souvent not Nwt)


%%%%%%%%%%%%%%%%%%% initialisation %%%%%%%%%%%%%%%%%%%
% ondelette=input('spline (1), Daubechies (2), ALDR (3)');
% test=input(' synthese de phi (h): 1; de psi (g):2   ?');
% nbvoies=input('nombre d octaves = ');
if nargin == 2
    disp = 0;
end
tee     = 1;
debut   = 2;
sens    = 1;



%%%%%%%%%%%%%%%%% recuperation coef ondelette %%%%%%%%%%
nf=2*regu;
if regu<4,
    listcoefdaub
else
    if sens==1,
        s = input('ondelette classique (0) ou ondelette la moins asymetrique (1) ?');
    end
    if s==1,
        listcoefdaub2
        h = fliplr(h);
    else
        listcoefdaub
    end
end
npb     = 0;
nph     = 0;
g       = (-1).^(nph:nph-1+max(size(h))).*fliplr(h);
hh      = h;
st      = 'Wavelet , regu=';
st      = [st,int2str(regu),'   nbvoies=',int2str(nbvoies)];
h2      = hh;
g2      = g;
clear h hh g


%%%% Nouveau v2
[h2bis nh2bis]  = flippeur(h2,0);
[h2 nph]        = convoluteur(h2,0,h2bis,nh2bis);

[g2bis ng2bis]  = flippeur(g2,0);
[g2 nph]        = convoluteur(g2,0,g2bis,ng2bis);


%%%%%%%%%%%%%% Initialisation des details/appro%%%%%%
eval(['detail',int2str(nbvoies),'=[0 1];']);





%%%%%%%%%%% generation de psi %%%%%%%%%%%%%%%%%%%%%%%
tee     = tee/2;
eval(['a=detail',int2str(nbvoies),';']);
debut   = 2*debut-1-nph;
dilate  = zeros(1,2*max(size(a)));
dilate(1:2:2*max(size(a))-1)=a;
a       = conv(g2,dilate);
clear dilate



%%%%%%%%%%%%%%%%%%%% affichage  %%%%%%%%%%%%%%%%%%%%%%%%%
ta      = 1:1:max(size(a));
ta      = ta-debut;
ta      = ta*tee;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for k=1:nbvoies-1,
    tee     = tee/2;
    debut   = 2*debut-1-npb;
    dilate  = zeros(1,2*max(size(a)));
    dilate(1:2:2*max(size(a))-1)=a;
    a       = conv(h2,dilate);
    clear dilate
    
    %%%%%%%%%%%%%%%%%%%% normalisation %%%%%%%%%%%%%%%%%%%%%
    ta      = 1:1:max(size(a));
    ta      = ta-debut;
    ta      = ta*tee;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end



%%%%%%%%%%%%%%%%%%%% normalisation et affichage %%%%%%%%%%
cste    = sqrt(tee*sum(a.*a));
a       = a/cste;

if disp > 0
    figure(disp);
    set(gca,'fontsize',20);
    plot(ta,a,'linewidth',2);
    xlabel('$t$','Interpreter','latex');
    ylabel('$\psi(t)$','Interpreter','latex');
    grid;
end






end

