

load('tab_etahOfBm.mat')
etah_ofbm = etah;

load('tab_etahOfGn.mat')
etah_ofgn = etah;

linewidth   = 2;
fontsize    = 20;
J           = 1:5;

figure(1);clf;
plot(hlist,etah_ofbm,'--k','linewidth',linewidth); hold on;
plot(hlist,etah_ofgn.val(J,:),'linewidth',linewidth);
xlabel('$h$','Interpreter','latex')
set(gca,'fontsize',fontsize)
l=legend('$\eta_h$','$\tilde{\tilde{\eta}}_{j=1,h}$','$\tilde{\tilde{\eta}}_{j=2,h}$','$\tilde{\tilde{\eta}}_{j=3,h}$','$\tilde{\tilde{\eta}}_{j=4,h}$','$\tilde{\tilde{\eta}}_{j=5,h}$');
set(l,'Interpreter','latex');
grid on;




%%

hh      = hot(8);
Jdisp   = [1:15];

figure(3);clf;
ii = 1;
for ind     = [1000:2000:9000];
    h       = ind/10000;
    ind     = ind+1;
    a(ii)=plot(Jdisp,log2(etah_ofgn.val(Jdisp,ind)),'linewidth',linewidth,'color',hh(ii,:));hold on;
    plot(Jdisp,log2(etah_ofbm(ind))*ones(1,length(Jdisp)),'linewidth',linewidth,'color',hh(ii,:),'linestyle','--');
    
    ii = ii+1;
end
set(gca,'fontsize',fontsize);
ylabel('$\log_2(\eta_h)$ [- -], $\log_2(\tilde{\tilde{\eta}}_{j,h})$ [-]','Interpreter','latex');
xlabel('$j=\log_{\;2}$ scale','Interpreter','latex')
l=legend(a,'$h=0.1$','$h=0.3$','$h=0.5$','$h=0.7$','$h=0.9$');
set(l,'Interpreter','latex');
grid on;



%%
clear all;
j = 1;
hlist = [0:.05:2];
for hh=1:length(hlist)
    h = hlist(hh);
    res(hh) = etahOfGn(h,j,2);
end

figure(1);clf;
plot(hlist,res);
grid on;


rb = res(1:floor(end/2))

[a b]=max(rb)
[c d]=min(abs(diff(rb)))