function [ Exx, Exy, Eyy] = parametricModelBivOfBm( h1, h2, rho, s1, s2, b, g, j1, j2, Nwt, muint )



J       = j1:j2;


s12     = (s1)^2;
s22     = (s2)^2;
b2      = (b)^2;
g2      = (g)^2;


invg2   = 1/(1+g2);
invb2   = 1/(1+b2);
invbg   = sqrt( invg2 * invb2 );


eta1    = etahOfBm(h1,Nwt);
eta2    = etahOfBm(h2,Nwt);
eta12   = etahOfBm((h1+h2)/2,Nwt);


l1      = eta1  * s12               * invg2 ;
l12     = eta12 * s1 * s2 * rho     * invbg ;
l2      = eta2  * s22               * invb2 ;


axx1    = l1;
axx12   = 2* l12 * b;
axx2    = l2  * b2;
 

axy1    = l1  * (-g);
axy12   = l12 * (1-b*g);
axy2    = l2  * b;

ayy1    = l1  * g2;
ayy12   = 2* l12 * (-g);
ayy2    = l2;

e1      = 2.^(J*(2*h1+1+2*muint));
e12     = 2.^(J*(h1+h2+1+2*muint));
e2      = 2.^(J*(2*h2+1+2*muint));


Exx     = axx1.*e1 + axx12.*e12 + axx2.*e2;
Exy     = axy1.*e1 + axy12.*e12 + axy2.*e2;
Eyy     = ayy1.*e1 + ayy12.*e12 + ayy2.*e2;


end

